/**
 * Copyright (c) 2011, 2014 - Lunifera GmbH (Gross Enzersdorf, Austria), Loetz GmbH&Co.KG (69115 Heidelberg, Germany)
 *  All rights reserved. This program and the accompanying materials 
 *  are made available under the terms of the Eclipse Public License 2.0  
 *  which accompanies this distribution, and is available at 
 *  https://www.eclipse.org/legal/epl-2.0/ 
 * 
 *  SPDX-License-Identifier: EPL-2.0 
 * 
 *  Based on ideas from Xtext, Xtend, Xcore
 *    
 *  Contributors:  
 *  		Florian Pirchner - Initial implementation 
 *  
 */
package org.eclipse.osbp.dsl.semantic.service.provider;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.util.ResourceLocator;

import org.eclipse.emf.ecore.EObject;

import org.eclipse.emf.edit.command.CommandParameter;

import org.eclipse.emf.edit.domain.EditingDomain;

import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IChildCreationExtender;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;

import org.eclipse.osbp.dsl.semantic.common.types.LFeature;
import org.eclipse.osbp.dsl.semantic.common.types.LType;
import org.eclipse.osbp.dsl.semantic.common.types.LTypedPackage;
import org.eclipse.osbp.dsl.semantic.common.types.OSBPTypesPackage;

import org.eclipse.osbp.dsl.semantic.common.types.util.OSBPTypesSwitch;

import org.eclipse.osbp.dsl.semantic.dto.LDto;
import org.eclipse.osbp.dsl.semantic.dto.OSBPDtoPackage;

import org.eclipse.osbp.dsl.semantic.dto.util.OSBPDtoSwitch;

import org.eclipse.osbp.dsl.semantic.service.OSBPServiceFactory;

import org.eclipse.osbp.dsl.semantic.service.util.OSBPServiceAdapterFactory;

/**
 * This is the factory that is used to provide the interfaces needed to support Viewers.
 * The adapters generated by this factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}.
 * The adapters also support Eclipse property sheets.
 * Note that most of the adapters are shared among multiple instances.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class OSBPServiceItemProviderAdapterFactory extends OSBPServiceAdapterFactory implements ComposeableAdapterFactory, IChangeNotifier, IDisposable {
	/**
	 * This keeps track of the root adapter factory that delegates to this adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ComposedAdapterFactory parentAdapterFactory;

	/**
	 * This is used to implement {@link org.eclipse.emf.edit.provider.IChangeNotifier}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IChangeNotifier changeNotifier = new ChangeNotifier();

	/**
	 * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected Collection<Object> supportedTypes = new ArrayList<Object>();

	/**
	 * This constructs an instance.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OSBPServiceItemProviderAdapterFactory() {
		supportedTypes.add(IEditingDomainItemProvider.class);
		supportedTypes.add(IStructuredItemContentProvider.class);
		supportedTypes.add(ITreeItemContentProvider.class);
		supportedTypes.add(IItemLabelProvider.class);
		supportedTypes.add(IItemPropertySource.class);
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.dsl.semantic.service.LServiceModel} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected LServiceModelItemProvider lServiceModelItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.dsl.semantic.service.LServiceModel}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createLServiceModelAdapter() {
		if (lServiceModelItemProvider == null) {
			lServiceModelItemProvider = new LServiceModelItemProvider(this);
		}

		return lServiceModelItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.dsl.semantic.service.LInjectedServices} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected LInjectedServicesItemProvider lInjectedServicesItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.dsl.semantic.service.LInjectedServices}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createLInjectedServicesAdapter() {
		if (lInjectedServicesItemProvider == null) {
			lInjectedServicesItemProvider = new LInjectedServicesItemProvider(this);
		}

		return lInjectedServicesItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.dsl.semantic.service.LInjectedService} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected LInjectedServiceItemProvider lInjectedServiceItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.dsl.semantic.service.LInjectedService}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createLInjectedServiceAdapter() {
		if (lInjectedServiceItemProvider == null) {
			lInjectedServiceItemProvider = new LInjectedServiceItemProvider(this);
		}

		return lInjectedServiceItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.dsl.semantic.service.LDTOService} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected LDTOServiceItemProvider ldtoServiceItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.dsl.semantic.service.LDTOService}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createLDTOServiceAdapter() {
		if (ldtoServiceItemProvider == null) {
			ldtoServiceItemProvider = new LDTOServiceItemProvider(this);
		}

		return ldtoServiceItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.dsl.semantic.service.LFilterableAttributes} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected LFilterableAttributesItemProvider lFilterableAttributesItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.dsl.semantic.service.LFilterableAttributes}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createLFilterableAttributesAdapter() {
		if (lFilterableAttributesItemProvider == null) {
			lFilterableAttributesItemProvider = new LFilterableAttributesItemProvider(this);
		}

		return lFilterableAttributesItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.dsl.semantic.service.LSortableAttributes} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected LSortableAttributesItemProvider lSortableAttributesItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.dsl.semantic.service.LSortableAttributes}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createLSortableAttributesAdapter() {
		if (lSortableAttributesItemProvider == null) {
			lSortableAttributesItemProvider = new LSortableAttributesItemProvider(this);
		}

		return lSortableAttributesItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.dsl.semantic.service.LChartService} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected LChartServiceItemProvider lChartServiceItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.dsl.semantic.service.LChartService}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createLChartServiceAdapter() {
		if (lChartServiceItemProvider == null) {
			lChartServiceItemProvider = new LChartServiceItemProvider(this);
		}

		return lChartServiceItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.dsl.semantic.service.LFreeService} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected LFreeServiceItemProvider lFreeServiceItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.dsl.semantic.service.LFreeService}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createLFreeServiceAdapter() {
		if (lFreeServiceItemProvider == null) {
			lFreeServiceItemProvider = new LFreeServiceItemProvider(this);
		}

		return lFreeServiceItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.dsl.semantic.service.LServiceOperation} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected LServiceOperationItemProvider lServiceOperationItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.dsl.semantic.service.LServiceOperation}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createLServiceOperationAdapter() {
		if (lServiceOperationItemProvider == null) {
			lServiceOperationItemProvider = new LServiceOperationItemProvider(this);
		}

		return lServiceOperationItemProvider;
	}

	/**
	 * This returns the root adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ComposeableAdapterFactory getRootAdapterFactory() {
		return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
	}

	/**
	 * This sets the composed adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory) {
		this.parentAdapterFactory = parentAdapterFactory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object type) {
		return supportedTypes.contains(type) || super.isFactoryForType(type);
	}

	/**
	 * This implementation substitutes the factory itself as the key for the adapter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter adapt(Notifier notifier, Object type) {
		return super.adapt(notifier, this);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object adapt(Object object, Object type) {
		if (isFactoryForType(type)) {
			Object adapter = super.adapt(object, type);
			if (!(type instanceof Class<?>) || (((Class<?>)type).isInstance(adapter))) {
				return adapter;
			}
		}

		return null;
	}

	/**
	 * This adds a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void addListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.addListener(notifyChangedListener);
	}

	/**
	 * This removes a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void removeListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.removeListener(notifyChangedListener);
	}

	/**
	 * This delegates to {@link #changeNotifier} and to {@link #parentAdapterFactory}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void fireNotifyChanged(Notification notification) {
		changeNotifier.fireNotifyChanged(notification);

		if (parentAdapterFactory != null) {
			parentAdapterFactory.fireNotifyChanged(notification);
		}
	}

	/**
	 * This disposes all of the item providers created by this factory. 
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void dispose() {
		if (lServiceModelItemProvider != null) lServiceModelItemProvider.dispose();
		if (lInjectedServicesItemProvider != null) lInjectedServicesItemProvider.dispose();
		if (lInjectedServiceItemProvider != null) lInjectedServiceItemProvider.dispose();
		if (ldtoServiceItemProvider != null) ldtoServiceItemProvider.dispose();
		if (lFilterableAttributesItemProvider != null) lFilterableAttributesItemProvider.dispose();
		if (lSortableAttributesItemProvider != null) lSortableAttributesItemProvider.dispose();
		if (lChartServiceItemProvider != null) lChartServiceItemProvider.dispose();
		if (lFreeServiceItemProvider != null) lFreeServiceItemProvider.dispose();
		if (lServiceOperationItemProvider != null) lServiceOperationItemProvider.dispose();
	}

	/**
	 * A child creation extender for the {@link OSBPDtoPackage}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static class OSBPDtoChildCreationExtender implements IChildCreationExtender {
		/**
		 * The switch for creating child descriptors specific to each extended class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		protected static class CreationSwitch extends OSBPDtoSwitch<Object> {
			/**
			 * The child descriptors being populated.
			 * <!-- begin-user-doc -->
			 * <!-- end-user-doc -->
			 * @generated
			 */
			protected List<Object> newChildDescriptors;

			/**
			 * The domain in which to create the children.
			 * <!-- begin-user-doc -->
			 * <!-- end-user-doc -->
			 * @generated
			 */
			protected EditingDomain editingDomain;

			/**
			 * Creates the a switch for populating child descriptors in the given domain.
			 * <!-- begin-user-doc -->
			 * <!-- end-user-doc -->
			 * @generated
			 */
			CreationSwitch(List<Object> newChildDescriptors, EditingDomain editingDomain) {
				this.newChildDescriptors = newChildDescriptors;
				this.editingDomain = editingDomain;
			}
			/**
			 * <!-- begin-user-doc -->
			 * <!-- end-user-doc -->
			 * @generated
			 */
			@Override
			public Object caseLDto(LDto object) {
				newChildDescriptors.add
					(createChildParameter
						(OSBPDtoPackage.Literals.LDTO__FEATURES,
						 OSBPServiceFactory.eINSTANCE.createLServiceOperation()));

				return null;
			}
 
			/**
			 * <!-- begin-user-doc -->
			 * <!-- end-user-doc -->
			 * @generated
			 */
			@Override
			public Object caseLFeature(LFeature object) {
				newChildDescriptors.add
					(createChildParameter
						(OSBPTypesPackage.Literals.LFEATURE__ANNOTATION_INFO,
						 OSBPServiceFactory.eINSTANCE.createLDTOService()));

				newChildDescriptors.add
					(createChildParameter
						(OSBPTypesPackage.Literals.LFEATURE__ANNOTATION_INFO,
						 OSBPServiceFactory.eINSTANCE.createLChartService()));

				newChildDescriptors.add
					(createChildParameter
						(OSBPTypesPackage.Literals.LFEATURE__ANNOTATION_INFO,
						 OSBPServiceFactory.eINSTANCE.createLFreeService()));

				newChildDescriptors.add
					(createChildParameter
						(OSBPTypesPackage.Literals.LFEATURE__ANNOTATION_INFO,
						 OSBPServiceFactory.eINSTANCE.createLServiceOperation()));

				return null;
			}
			/**
			 * <!-- begin-user-doc -->
			 * <!-- end-user-doc -->
			 * @generated
			 */
			protected CommandParameter createChildParameter(Object feature, Object child) {
				return new CommandParameter(null, feature, child);
			}

		}

		/**
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		public Collection<Object> getNewChildDescriptors(Object object, EditingDomain editingDomain) {
			ArrayList<Object> result = new ArrayList<Object>();
			new CreationSwitch(result, editingDomain).doSwitch((EObject)object);
			return result;
		}

		/**
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		public ResourceLocator getResourceLocator() {
			return ServiceEditPlugin.INSTANCE;
		}
	}

	/**
	 * A child creation extender for the {@link OSBPTypesPackage}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static class OSBPTypesChildCreationExtender implements IChildCreationExtender {
		/**
		 * The switch for creating child descriptors specific to each extended class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		protected static class CreationSwitch extends OSBPTypesSwitch<Object> {
			/**
			 * The child descriptors being populated.
			 * <!-- begin-user-doc -->
			 * <!-- end-user-doc -->
			 * @generated
			 */
			protected List<Object> newChildDescriptors;

			/**
			 * The domain in which to create the children.
			 * <!-- begin-user-doc -->
			 * <!-- end-user-doc -->
			 * @generated
			 */
			protected EditingDomain editingDomain;

			/**
			 * Creates the a switch for populating child descriptors in the given domain.
			 * <!-- begin-user-doc -->
			 * <!-- end-user-doc -->
			 * @generated
			 */
			CreationSwitch(List<Object> newChildDescriptors, EditingDomain editingDomain) {
				this.newChildDescriptors = newChildDescriptors;
				this.editingDomain = editingDomain;
			}
			/**
			 * <!-- begin-user-doc -->
			 * <!-- end-user-doc -->
			 * @generated
			 */
			@Override
			public Object caseLFeature(LFeature object) {
				newChildDescriptors.add
					(createChildParameter
						(OSBPTypesPackage.Literals.LFEATURE__ANNOTATION_INFO,
						 OSBPServiceFactory.eINSTANCE.createLDTOService()));

				newChildDescriptors.add
					(createChildParameter
						(OSBPTypesPackage.Literals.LFEATURE__ANNOTATION_INFO,
						 OSBPServiceFactory.eINSTANCE.createLChartService()));

				newChildDescriptors.add
					(createChildParameter
						(OSBPTypesPackage.Literals.LFEATURE__ANNOTATION_INFO,
						 OSBPServiceFactory.eINSTANCE.createLFreeService()));

				newChildDescriptors.add
					(createChildParameter
						(OSBPTypesPackage.Literals.LFEATURE__ANNOTATION_INFO,
						 OSBPServiceFactory.eINSTANCE.createLServiceOperation()));

				return null;
			}
 
			/**
			 * <!-- begin-user-doc -->
			 * <!-- end-user-doc -->
			 * @generated
			 */
			@Override
			public Object caseLTypedPackage(LTypedPackage object) {
				newChildDescriptors.add
					(createChildParameter
						(OSBPTypesPackage.Literals.LTYPED_PACKAGE__TYPES,
						 OSBPServiceFactory.eINSTANCE.createLDTOService()));

				newChildDescriptors.add
					(createChildParameter
						(OSBPTypesPackage.Literals.LTYPED_PACKAGE__TYPES,
						 OSBPServiceFactory.eINSTANCE.createLChartService()));

				newChildDescriptors.add
					(createChildParameter
						(OSBPTypesPackage.Literals.LTYPED_PACKAGE__TYPES,
						 OSBPServiceFactory.eINSTANCE.createLFreeService()));

				return null;
			}
 
			/**
			 * <!-- begin-user-doc -->
			 * <!-- end-user-doc -->
			 * @generated
			 */
			@Override
			public Object caseLType(LType object) {
				newChildDescriptors.add
					(createChildParameter
						(OSBPTypesPackage.Literals.LTYPE__ANNOTATION_INFO,
						 OSBPServiceFactory.eINSTANCE.createLDTOService()));

				newChildDescriptors.add
					(createChildParameter
						(OSBPTypesPackage.Literals.LTYPE__ANNOTATION_INFO,
						 OSBPServiceFactory.eINSTANCE.createLChartService()));

				newChildDescriptors.add
					(createChildParameter
						(OSBPTypesPackage.Literals.LTYPE__ANNOTATION_INFO,
						 OSBPServiceFactory.eINSTANCE.createLFreeService()));

				newChildDescriptors.add
					(createChildParameter
						(OSBPTypesPackage.Literals.LTYPE__ANNOTATION_INFO,
						 OSBPServiceFactory.eINSTANCE.createLServiceOperation()));

				return null;
			}
 
			/**
			 * <!-- begin-user-doc -->
			 * <!-- end-user-doc -->
			 * @generated
			 */
			protected CommandParameter createChildParameter(Object feature, Object child) {
				return new CommandParameter(null, feature, child);
			}

		}

		/**
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		public Collection<Object> getNewChildDescriptors(Object object, EditingDomain editingDomain) {
			ArrayList<Object> result = new ArrayList<Object>();
			new CreationSwitch(result, editingDomain).doSwitch((EObject)object);
			return result;
		}

		/**
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		public ResourceLocator getResourceLocator() {
			return ServiceEditPlugin.INSTANCE;
		}
	}

}
